<template>
  <div>
    <template v-if="label">
      <label :for="label + random" class="label-formulario">
        {{ label }}
      </label>
    </template>
    <ComponentImgRecomendado :pixeles="pixeles" :peso="pesoString" />
    <div class="row">
      <div
        v-bind:class="[
          value ? 'col-lg-6 col-md-6 col-sm-12 col-xs-12  text-center' : '',
        ]"
        v-if="value"
      >
        <q-img :src="value" style="height: 200px" contain> </q-img>
      </div>
      <div
        v-bind:class="[
          value
            ? 'col-lg-6 col-md-6 col-sm-12 col-xs-12  text-center '
            : 'col-lg-12 col-md-12 col-sm-12 col-xs-12    text-center',
        ]"
      >
        <vue-dropzone
          ref="ref_image"
          @vdropzone-file-added="
            $validate_image.validateImageDropzone(
              $event,
              $refs.ref_image.dropzone,
              1,
              pesoNumber,
              pesoString
            )
          "
          @vdropzone-files-added="handleAddedFiles($event)"
          @vdropzone-removed-file="removeFile($event)"
          :id="label + random"
          :options="dropzoneOptions"
          :duplicateCheck="true"
          :useCustomSlot="true"
          ><div class="dropzone-custom-content">
            <h5 class="dropzone-custom-title text-primary">
              Suelte la imagen aquí o haga click para cargarlo.
            </h5>
          </div>
        </vue-dropzone>
      </div>
    </div>
    <div
      v-for="(el, i) in errors"
      :key="i"
      class="q-field--error q-field__bottom q-field--dense margin-top-error-custom"
      v-if="i == variable"
    >
      <div class="q-field__bottom">
        <div class="q-field__messages col">
          <div>
            {{ el[0] }}
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import vue2Dropzone from "vue2-dropzone";
import ComponentImgRecomendado from "../../components/img/recomendado";
export default {
  props: {
    label: String,
    folder: String,
    variable: String,
    errors: Object,
    valueParent: null,
    imagesUrl: String,
    pixeles: String,
    pesoString: String,
    pesoNumber: String,
  },
  components: {
    vueDropzone: vue2Dropzone,
    ComponentImgRecomendado,
  },
  data() {
    return {
      value: "",
      dropzoneOptions: {
        url: "/",
        maxFiles: 1,
        acceptedFiles: "image/png,image/jpeg,image/jpg,image/svg+xml",
        autoProcessQueue: false,
        thumbnailWidth: 150,
        addRemoveLinks: true,
        dictRemoveFile: "Remover",
      },
      random: Math.ceil(Math.random() * 10),
    };
  },
  methods: {
    handleAddedFiles(e) {
      setTimeout(() => {
        this.$emit("update:value", this.$refs.ref_image.dropzone.files[0]);
      }, 500);
    },
    removeFile(e) {
      this.$emit("update:value", "");
    },
  },
  watch: {
    valueParent: {
      immediate: true,
      handler: function (newValue) {
        if (newValue instanceof File) {
        } else {
          this.value = newValue;
        }
      },
    },
    value: function (newValue, oldValue) {
      if (this.$refs.ref_image) {
        if (this.$refs.ref_image.dropzone.files.length > 0) {
          this.$refs.ref_image.removeFile(
            this.$refs.ref_image.dropzone.files[0]
          );
        }
      }
      this.$emit("update:value", newValue);
    },
  },
};
</script>